#include "chip.h"

#ifdef CHIP_CFG_GPV_ARTD_WR_QOS
    #define CHIP_GPV_ARTD_WR_QOS    CHIP_CFG_GPV_ARTD_WR_QOS
#else
    #define CHIP_GPV_ARTD_WR_QOS    0
#endif
#ifdef CHIP_CFG_GPV_ARTD_RD_QOS
    #define CHIP_GPV_ARTD_RD_QOS    CHIP_CFG_GPV_ARTD_RD_QOS
#else
    #define CHIP_GPV_ARTD_RD_QOS    0
#endif

#ifdef CHIP_CFG_GPV_CM7_WR_QOS
    #define CHIP_GPV_CM7_WR_QOS     CHIP_CFG_GPV_CM7_WR_QOS
#else
    #define CHIP_GPV_CM7_WR_QOS     0
#endif
#ifdef CHIP_CFG_GPV_CM7_RD_QOS
    #define CHIP_GPV_CM7_RD_QOS     CHIP_CFG_GPV_CM7_RD_QOS
#else
    #define CHIP_GPV_CM7_RD_QOS     0
#endif

#ifdef CHIP_CFG_GPV_SDMMC1_WR_QOS
    #define CHIP_GPV_SDMMC1_WR_QOS  CHIP_CFG_GPV_SDMMC1_WR_QOS
#else
    #define CHIP_GPV_SDMMC1_WR_QOS  0
#endif
#ifdef CHIP_CFG_GPV_SDMMC1_RD_QOS
    #define CHIP_GPV_SDMMC1_RD_QOS  CHIP_CFG_GPV_SDMMC1_RD_QOS
#else
    #define CHIP_GPV_SDMMC1_RD_QOS  0
#endif

#ifdef CHIP_CFG_GPV_MDMA_WR_QOS
    #define CHIP_GPV_MDMA_WR_QOS    CHIP_CFG_GPV_MDMA_WR_QOS
#else
    #define CHIP_GPV_MDMA_WR_QOS    0
#endif
#ifdef CHIP_CFG_GPV_MDMA_RD_QOS
    #define CHIP_GPV_MDMA_RD_QOS    CHIP_CFG_GPV_MDMA_RD_QOS
#else
    #define CHIP_GPV_MDMA_RD_QOS    0
#endif

#ifdef CHIP_CFG_GPV_DMA2D_WR_QOS
    #define CHIP_GPV_DMA2D_WR_QOS   CHIP_CFG_GPV_DMA2D_WR_QOS
#else
    #define CHIP_GPV_DMA2D_WR_QOS   0
#endif
#ifdef CHIP_CFG_GPV_DMA2D_RD_QOS
    #define CHIP_GPV_DMA2D_RD_QOS   CHIP_CFG_GPV_DMA2D_RD_QOS
#else
    #define CHIP_GPV_DMA2D_RD_QOS   0
#endif

#ifdef CHIP_CFG_GPV_LTDC_WR_QOS
    #define CHIP_GPV_LTDC_WR_QOS    CHIP_CFG_GPV_LTDC_WR_QOS
#else
    #define CHIP_GPV_LTDC_WR_QOS    0
#endif
#ifdef CHIP_CFG_GPV_LTDC_RD_QOS
    #define CHIP_GPV_LTDC_RD_QOS    CHIP_CFG_GPV_LTDC_RD_QOS
#else
    #define CHIP_GPV_LTDC_RD_QOS    0
#endif

#ifdef CHIP_CFG_GPV_ARTI_WR_QOS
    #define CHIP_GPV_ARTI_WR_QOS    CHIP_CFG_GPV_ARTI_WR_QOS
#else
    #define CHIP_GPV_ARTI_WR_QOS    0
#endif
#ifdef CHIP_CFG_GPV_ARTI_RD_QOS
    #define CHIP_GPV_ARTI_RD_QOS    CHIP_CFG_GPV_ARTI_RD_QOS
#else
    #define CHIP_GPV_ARTI_RD_QOS    0
#endif

/* Доступ только для ядра Cortex-M7 */
#if !defined CHIP_CORETYPE_CM4
void chip_gpv_init(void) {
#ifdef CHIP_DEV_STM32H743
    if (chip_get_revision_id() < CHIP_REV_ID_V) {
        /* Change  the switch matrix read issuing capability to 1 for the AXI SRAM target (Target 7) ERRATA 2.2.9 */
        CHIP_REGS_GPV->AXI_TARG7_FN_MOD = 0x00000001;
    }
#endif

    CHIP_REGS_GPV->AXI_INI1_READ_QOS = CHIP_GPV_ARTD_RD_QOS;
    CHIP_REGS_GPV->AXI_INI1_WRITE_QOS = CHIP_GPV_ARTD_WR_QOS;

    CHIP_REGS_GPV->AXI_INI2_READ_QOS = CHIP_GPV_CM7_RD_QOS;
    CHIP_REGS_GPV->AXI_INI2_WRITE_QOS = CHIP_GPV_CM7_WR_QOS;

    CHIP_REGS_GPV->AXI_INI3_READ_QOS = CHIP_GPV_SDMMC1_RD_QOS;
    CHIP_REGS_GPV->AXI_INI3_WRITE_QOS = CHIP_GPV_SDMMC1_WR_QOS;

    CHIP_REGS_GPV->AXI_INI4_READ_QOS = CHIP_GPV_MDMA_RD_QOS;
    CHIP_REGS_GPV->AXI_INI4_WRITE_QOS = CHIP_GPV_MDMA_WR_QOS;

    CHIP_REGS_GPV->AXI_INI5_READ_QOS = CHIP_GPV_DMA2D_RD_QOS;
    CHIP_REGS_GPV->AXI_INI5_WRITE_QOS = CHIP_GPV_DMA2D_WR_QOS;

    CHIP_REGS_GPV->AXI_INI6_READ_QOS = CHIP_GPV_LTDC_RD_QOS;
    CHIP_REGS_GPV->AXI_INI6_WRITE_QOS = CHIP_GPV_LTDC_WR_QOS;

#if CHIP_DEV_SUPPORT_CORE_CM4
    CHIP_REGS_GPV->AXI_INI7_READ_QOS = CHIP_GPV_ARTI_RD_QOS;
    CHIP_REGS_GPV->AXI_INI7_WRITE_QOS = CHIP_GPV_ARTI_WR_QOS;
#endif
}
#endif
